Package: html2pdfR
Type: Package
Title: Convert Local 'HTML' and 'XHTML' Files to 'PDF'
Version: 0.1.0
Authors@R: person("Lijin", "Arakkandathil Thekkathil", email = "lijin5673@gmail.com", role = c("aut", "cre"))
Description: Provides functions for converting local 'HTML' and 'XHTML' files to 'PDF' using an external backend. The package includes helper functions for backend setup, file conversion, and an optional 'Tk' graphical interface.
License: GPL-3
Encoding: UTF-8
Imports: utils, tools, tcltk
Suggests: roxygen2, testthat
URL: https://github.com/Lijin-5673/html2pdfR
BugReports: https://github.com/Lijin-5673/html2pdfR/issues
NeedsCompilation: no
Config/roxygen2/version: 8.0.0
Packaged: 2026-05-09 15:01:02 UTC; lijin
Author: Lijin Arakkandathil Thekkathil [aut, cre]
Maintainer: Lijin Arakkandathil Thekkathil <lijin5673@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-13 19:20:02 UTC
Built: R 4.6.0; ; 2026-05-13 20:08:18 UTC; unix

Package: html2pdfR
Type: Package
Title: Convert Local 'HTML' and 'XHTML' Files to 'PDF'
Version: 0.1.0
Authors@R: person("Lijin", "Arakkandathil Thekkathil", email = "lijin5673@gmail.com", role = c("aut", "cre"))
Description: Provides functions for converting local 'HTML' and 'XHTML' files to 'PDF' using an external backend. The package includes helper functions for backend setup, file conversion, and an optional 'Tk' graphical interface.
License: GPL-3
Encoding: UTF-8
Imports: utils, tools, tcltk
Suggests: roxygen2, testthat
URL: https://github.com/Lijin-5673/html2pdfR
BugReports: https://github.com/Lijin-5673/html2pdfR/issues
NeedsCompilation: no
Config/roxygen2/version: 8.0.0
Packaged: 2026-05-09 15:01:02 UTC; lijin
Author: Lijin Arakkandathil Thekkathil [aut, cre]
Maintainer: Lijin Arakkandathil Thekkathil <lijin5673@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-13 19:20:02 UTC
Built: R 4.6.0; ; 2026-05-13 20:12:08 UTC; unix

# html2pdfR

html2pdfR is an R package for converting local HTML and XHTML files to PDF using an external backend.

## Overview

The package provides a simple R interface for XHTML-to-PDF conversion.

The R package contains only R code and documentation. The required backend files are managed separately and can be downloaded when needed.

## Features

- Convert HTML and XHTML files to PDF
- Download and configure the required backend automatically
- Launch an optional Tk GUI for interactive use
- Keep package source separate from third-party executables

## Installation

```r
# install.packages("remotes")
remotes::install_github("Lijin-5673/html2pdfR")
```

## Backend setup

This package does not bundle third-party executable binaries inside the R package source.

If the backend is not already installed, the package can download it from the project's GitHub Releases.

You can also install the backend manually:

```r
library(html2pdfR)
install_html2pdf_backend()
```

Or set the path to an existing backend executable:

```r
library(html2pdfR)
set_html2pdf_backend("C:/path/to/converter_backend.exe")
```

## Basic usage

```r
library(html2pdfR)

convert_html_to_pdf("C:/path/to/file.xhtml")
```

If the backend is missing, the package will prompt to install it during interactive use.

## GUI usage

```r
library(html2pdfR)

launch_html2pdf_app()
```

The GUI will prompt to download the backend if it is not already installed.

## Main functions

- `find_html2pdf_backend()`
- `set_html2pdf_backend(path)`
- `install_html2pdf_backend(url = NULL)`
- `convert_html_to_pdf(input)`
- `launch_html2pdf_app()`

## Notes

- The backend executable is managed outside the package source.
- Backend files are intended to be downloaded from GitHub Releases.
- The package is currently focused on interactive desktop use.

## License

GPL-3

# This file is part of the standard setup for testthat.
# It is recommended that you do not modify it.
#
# Where should you do additional test configuration?
# Learn more about the roles of various files in:
# * https://r-pkgs.org/testing-design.html#sec-tests-files-overview
# * https://testthat.r-lib.org/articles/special-files.html

library(testthat)
library(html2pdfR)

test_check("html2pdfR")

#' Backend release URL
#'
#' @return URL to the backend zip file hosted on GitHub Releases.
backend_release_url <- function() {
  "https://github.com/Lijin-5673/html2pdfR/releases/download/backend-v1/converter_backend.zip"
}

#' Ensure backend is available
#'
#' @param ask Logical; ask before downloading when interactive.
#' @param verbose Logical; show progress messages.
#'
#' @return Path to the backend executable.
#' @keywords internal
ensure_html2pdf_backend <- function(ask = interactive(), verbose = FALSE) {
  exe <- find_html2pdf_backend()
  
  if (nzchar(exe) && file.exists(exe)) {
    return(exe)
  }
  
  if (!ask) {
    stop(
      paste(
        "Backend not configured.",
        "Run install_html2pdf_backend() first,",
        "or call launch_html2pdf_app() in an interactive session."
      ),
      call. = FALSE
    )
  }
  
  if (interactive() && capabilities("tcltk")) {
    ans <- tcltk::tkmessageBox(
      title = "Backend Required",
      message = paste(
        "The HTML-to-PDF backend is not installed.",
        "Do you want to download it now?"
      ),
      icon = "question",
      type = "yesno",
      default = "yes"
    )
    
    if (as.character(ans) != "yes") {
      stop("Backend installation cancelled.", call. = FALSE)
    }
  }
  
  install_html2pdf_backend(
    url = backend_release_url(),
    ask = FALSE,
    verbose = verbose
  )
}

#' Launch graphical converter application
#'
#' @return Opens a 'Tk' graphical interface for file selection and conversion.
#' @export
launch_html2pdf_app <- function() {
  backend_exe <- ensure_html2pdf_backend(ask = TRUE, verbose = TRUE)
  
  if (!nzchar(backend_exe) || !file.exists(backend_exe)) {
    stop("Backend installation failed.", call. = FALSE)
  }
  
  selected_file <- NULL
  file_var <- tcltk::tclVar("No file selected")
  status_var <- tcltk::tclVar("Waiting...")
  is_running <- FALSE
  anim_value <- 0
  anim_direction <- 1
  
  write_log <- function(msg) {
    tcltk::tkinsert(log_text, "end", paste0(msg, "\n"))
    tcltk::tkyview.moveto(log_text, 1)
    tcltk::tcl("update")
  }
  
  set_status <- function(msg) {
    tcltk::tclvalue(status_var) <- msg
    tcltk::tcl("update")
  }
  
  animate_progress <- function() {
    if (!is_running) {
      return()
    }
    
    anim_value <<- anim_value + (anim_direction * 6)
    
    if (anim_value >= 100) {
      anim_value <<- 100
      anim_direction <<- -1
    } else if (anim_value <= 0) {
      anim_value <<- 0
      anim_direction <<- 1
    }
    
    tcltk::tkconfigure(progress, value = anim_value)
    tcltk::tcl("after", 90, animate_progress)
  }
  
  start_progress_animation <- function() {
    is_running <<- TRUE
    animate_progress()
  }
  
  stop_progress_animation <- function(final_value = 0) {
    is_running <<- FALSE
    tcltk::tkconfigure(progress, value = final_value)
    tcltk::tcl("update")
  }
  
  choose_file <- function() {
    file <- tcltk::tclvalue(tcltk::tkgetOpenFile(
      title = "Choose HTML or XHTML file",
      filetypes = "{{HTML/XHTML files} {.html .htm .xhtml}} {{All files} *}"
    ))
    
    if (nzchar(file)) {
      selected_file <<- normalizePath(file, winslash = "/", mustWork = TRUE)
      tcltk::tclvalue(file_var) <- selected_file
      tcltk::tkconfigure(convert_btn, state = "normal")
    }
  }
  
  start_conversion <- function() {
    if (is.null(selected_file) || !nzchar(selected_file)) {
      tcltk::tkmessageBox(
        title = "Error",
        message = "Please choose an HTML or XHTML file first.",
        icon = "error",
        type = "ok"
      )
      return()
    }
    
    tcltk::tkdelete(log_text, "1.0", "end")
    anim_value <<- 0
    anim_direction <<- 1
    
    set_status("Starting conversion")
    tcltk::tkconfigure(choose_btn, state = "disabled")
    tcltk::tkconfigure(convert_btn, state = "disabled")
    start_progress_animation()
    tcltk::tcl("update")
    
    output <- tryCatch(
      {
        system2(
          command = backend_exe,
          args = shQuote(selected_file),
          stdout = TRUE,
          stderr = TRUE
        )
      },
      error = function(e) {
        structure(c(paste("Error:", conditionMessage(e))), status = 1)
      }
    )
    
    status <- attr(output, "status")
    if (is.null(status)) {
      status <- 0
    }
    
    if (length(output) > 0) {
      for (line in output) {
        write_log(line)
      }
    }
    
    tcltk::tkconfigure(choose_btn, state = "normal")
    tcltk::tkconfigure(convert_btn, state = "normal")
    
    if (status == 0) {
      stop_progress_animation(100)
      set_status("Done")
      output_pdf <- sub("\\.[^.]+$", ".pdf", selected_file)
      
      tcltk::tkmessageBox(
        title = "Success",
        message = paste("PDF created successfully:\n\n", output_pdf),
        icon = "info",
        type = "ok"
      )
    } else {
      stop_progress_animation(0)
      set_status("Failed")
      
      tcltk::tkmessageBox(
        title = "Error",
        message = "Conversion failed. See the log output.",
        icon = "error",
        type = "ok"
      )
    }
  }
  
  tt <- tcltk::tktoplevel()
  tcltk::tkwm.title(tt, "HTML/XHTML to PDF Converter")
  tcltk::tkwm.geometry(tt, "780x480")
  
  top_frame <- tcltk::ttkframe(tt, padding = 12)
  tcltk::tkpack(top_frame, fill = "x")
  
  file_label <- tcltk::ttklabel(top_frame, textvariable = file_var)
  tcltk::tkpack(file_label, anchor = "w", pady = c(0, 8))
  
  button_frame <- tcltk::ttkframe(top_frame)
  tcltk::tkpack(button_frame, fill = "x")
  
  choose_btn <- tcltk::ttkbutton(
    button_frame,
    text = "Choose File",
    command = choose_file
  )
  tcltk::tkpack(choose_btn, side = "left", padx = c(0, 8))
  
  convert_btn <- tcltk::ttkbutton(
    button_frame,
    text = "Convert to PDF",
    command = start_conversion,
    state = "disabled"
  )
  tcltk::tkpack(convert_btn, side = "left")
  
  progress <- tcltk::ttkprogressbar(
    tt,
    mode = "determinate",
    maximum = 100,
    value = 0
  )
  tcltk::tkpack(progress, fill = "x", padx = 12, pady = c(6, 10))
  
  status_label <- tcltk::ttklabel(tt, textvariable = status_var)
  tcltk::tkpack(status_label, anchor = "w", padx = 12)
  
  log_text <- tcltk::tktext(tt, height = 20, wrap = "word")
  tcltk::tkpack(log_text, fill = "both", expand = TRUE, padx = 12, pady = 12)
  
  tcltk::tkfocus(tt)
  tcltk::tkwait.window(tt)
}

#' Install external backend from GitHub Releases
#'
#' @param url Optional URL to a backend zip file. If omitted, the default
#'   GitHub Releases URL is used.
#' @param ask Logical; ask before downloading. Defaults to interactive().
#' @param overwrite Logical; overwrite an existing backend installation.
#' @param timeout Download timeout in seconds.
#' @param verbose Logical; show progress messages.
#'
#' @return Invisibly returns the installed executable path.
#' @export
install_html2pdf_backend <- function(
    url = backend_release_url(),
    ask = interactive(),
    overwrite = FALSE,
    timeout = 300,
    verbose = FALSE
) {
  if (!nzchar(url)) {
    stop("A backend download URL is required.", call. = FALSE)
  }
  
  target_dir <- backend_root()
  zip_file <- file.path(target_dir, "converter_backend.zip")
  unpack_dir <- backend_default_dir()
  
  if (dir.exists(unpack_dir) && !overwrite) {
    exe <- list.files(
      unpack_dir,
      pattern = "HtmlToPdfConverter\\.exe$",
      recursive = TRUE,
      full.names = TRUE
    )
    if (length(exe) > 0) {
      exe <- normalizePath(exe[1], winslash = "/", mustWork = TRUE)
      set_html2pdf_backend(exe)
      return(invisible(exe))
    }
  }
  
  if (ask) {
    ans <- tolower(trimws(readline("Download backend now? [y/n]: ")))
    if (!identical(ans, "y")) {
      stop("Installation cancelled by user.", call. = FALSE)
    }
  }
  
  dir.create(target_dir, recursive = TRUE, showWarnings = FALSE)
  
  old_timeout <- getOption("timeout")
  on.exit(options(timeout = old_timeout), add = TRUE)
  options(timeout = max(timeout, old_timeout))
  
  if (verbose) {
    message("Downloading backend archive from GitHub Releases.")
  }
  
  utils::download.file(url, destfile = zip_file, mode = "wb", quiet = !verbose)
  
  if (dir.exists(unpack_dir)) {
    unlink(unpack_dir, recursive = TRUE, force = TRUE)
  }
  dir.create(unpack_dir, recursive = TRUE, showWarnings = FALSE)
  
  if (verbose) {
    message("Unpacking backend archive.")
  }
  
  utils::unzip(zip_file, exdir = unpack_dir)
  
  exe <- list.files(
    unpack_dir,
    pattern = "HtmlToPdfConverter\\.exe$",
    recursive = TRUE,
    full.names = TRUE
  )
  
  if (!length(exe)) {
    stop("Backend executable not found after download and unzip.", call. = FALSE)
  }
  
  exe <- normalizePath(exe[1], winslash = "/", mustWork = TRUE)
  set_html2pdf_backend(exe)
  
  if (verbose) {
    message("Backend installed successfully.")
  }
  
  invisible(exe)
}

#' Convert local 'HTML' or 'XHTML' file to 'PDF'
#'
#' @param input Path to a local HTML, HTM, or XHTML file.
#' @param verbose Logical; show progress messages.
#'
#' @return Invisibly returns the expected output PDF path.
#' @export
#'
#' @examples
#' \dontrun{
#' convert_html_to_pdf("C:/path/to/file.xhtml")
#' }
convert_html_to_pdf <- function(input, verbose = FALSE) {
  input <- normalizePath(input, winslash = "/", mustWork = TRUE)
  exe <- ensure_html2pdf_backend(ask = interactive(), verbose = verbose)
  
  if (verbose) {
    message("Starting conversion.")
  }
  
  out <- system2(
    command = exe,
    args = shQuote(input),
    stdout = TRUE,
    stderr = TRUE
  )
  
  status <- attr(out, "status")
  if (is.null(status)) {
    status <- 0
  }
  
  if (status != 0) {
    stop(paste(out, collapse = "\n"), call. = FALSE)
  }
  
  if (verbose) {
    message("Conversion completed successfully.")
  }
  
  invisible(sub("\\.[^.]+$", ".pdf", input))
}

#' Get backend root directory
#'
#' @return Path to the package user data directory.
backend_root <- function() {
  tools::R_user_dir("html2pdfR", which = "data")
}

#' Get backend config file path
#'
#' @return Path to the config file storing backend executable location.
backend_config_file <- function() {
  file.path(backend_root(), "backend_path.txt")
}

#' Get default backend directory
#'
#' @return Path to the default backend installation directory.
backend_default_dir <- function() {
  file.path(backend_root(), "converter_backend")
}

#' Get default backend executable path
#'
#' @return Path to the default converter executable.
backend_default_exe <- function() {
  file.path(backend_default_dir(), "converter_backend.exe")
}

#' Find configured backend executable
#'
#' @return Path to backend executable, or an empty string if not found.
#' @export
find_html2pdf_backend <- function() {
  cfg <- backend_config_file()
  
  if (file.exists(cfg)) {
    p <- trimws(readLines(cfg, warn = FALSE, encoding = "UTF-8"))
    if (length(p) > 0 && nzchar(p[1]) && file.exists(p[1])) {
      return(normalizePath(p[1], winslash = "/", mustWork = TRUE))
    }
  }
  
  p <- backend_default_exe()
  if (file.exists(p)) {
    return(normalizePath(p, winslash = "/", mustWork = TRUE))
  }
  
  ""
}

#' Set backend executable path
#'
#' @param path Path to the backend executable.
#'
#' @return Invisibly returns the normalized backend path.
#' @export
set_html2pdf_backend <- function(path) {
  path <- normalizePath(path, winslash = "/", mustWork = TRUE)
  dir.create(backend_root(), recursive = TRUE, showWarnings = FALSE)
  writeLines(path, backend_config_file(), useBytes = TRUE)
  invisible(path)
}

test_that("find_html2pdf_backend returns empty string when no backend is configured", {
  old_cfg <- backend_config_file()
  had_cfg <- file.exists(old_cfg)
  tmp_backup <- tempfile(fileext = ".txt")
  
  if (had_cfg) {
    file.copy(old_cfg, tmp_backup, overwrite = TRUE)
    unlink(old_cfg)
  }
  
  on.exit({
    if (file.exists(old_cfg)) {
      unlink(old_cfg)
    }
    if (had_cfg && file.exists(tmp_backup)) {
      file.copy(tmp_backup, old_cfg, overwrite = TRUE)
    }
  }, add = TRUE)
  
  expect_identical(find_html2pdf_backend(), "")
})

test_that("set_html2pdf_backend errors for missing path", {
  expect_error(
    set_html2pdf_backend(tempfile(fileext = ".exe"))
  )
})

test_that("convert_html_to_pdf errors when backend is not configured", {
  html_file <- tempfile(fileext = ".html")
  writeLines("<html><body><h1>Test</h1></body></html>", html_file)
  
  testthat::local_mocked_bindings(
    ensure_html2pdf_backend = function(ask = interactive(), verbose = FALSE) {
      stop("Backend not configured", call. = FALSE)
    }
  )
  
  expect_error(
    convert_html_to_pdf(html_file),
    "Backend not configured"
  )
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/convert.R
\name{convert_html_to_pdf}
\alias{convert_html_to_pdf}
\title{Convert local 'HTML' or 'XHTML' file to 'PDF'}
\usage{
convert_html_to_pdf(input, verbose = FALSE)
}
\arguments{
\item{input}{Path to a local HTML, HTM, or XHTML file.}

\item{verbose}{Logical; show progress messages.}
}
\value{
Invisibly returns the expected output PDF path.
}
\description{
Convert local 'HTML' or 'XHTML' file to 'PDF'
}
\examples{
\dontrun{
convert_html_to_pdf("C:/path/to/file.xhtml")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/paths.R
\name{set_html2pdf_backend}
\alias{set_html2pdf_backend}
\title{Set backend executable path}
\usage{
set_html2pdf_backend(path)
}
\arguments{
\item{path}{Path to the backend executable.}
}
\value{
Invisibly returns the normalized backend path.
}
\description{
Set backend executable path
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/paths.R
\name{backend_config_file}
\alias{backend_config_file}
\title{Get backend config file path}
\usage{
backend_config_file()
}
\value{
Path to the config file storing backend executable location.
}
\description{
Get backend config file path
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/paths.R
\name{backend_default_exe}
\alias{backend_default_exe}
\title{Get default backend executable path}
\usage{
backend_default_exe()
}
\value{
Path to the default converter executable.
}
\description{
Get default backend executable path
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/backend.R
\name{backend_release_url}
\alias{backend_release_url}
\title{Backend release URL}
\usage{
backend_release_url()
}
\value{
URL to the backend zip file hosted on GitHub Releases.
}
\description{
Backend release URL
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/install.R
\name{install_html2pdf_backend}
\alias{install_html2pdf_backend}
\title{Install external backend from GitHub Releases}
\usage{
install_html2pdf_backend(
  url = backend_release_url(),
  ask = interactive(),
  overwrite = FALSE,
  timeout = 300,
  verbose = FALSE
)
}
\arguments{
\item{url}{Optional URL to a backend zip file. If omitted, the default
GitHub Releases URL is used.}

\item{ask}{Logical; ask before downloading. Defaults to interactive().}

\item{overwrite}{Logical; overwrite an existing backend installation.}

\item{timeout}{Download timeout in seconds.}

\item{verbose}{Logical; show progress messages.}
}
\value{
Invisibly returns the installed executable path.
}
\description{
Install external backend from GitHub Releases
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/paths.R
\name{backend_root}
\alias{backend_root}
\title{Get backend root directory}
\usage{
backend_root()
}
\value{
Path to the package user data directory.
}
\description{
Get backend root directory
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/backend.R
\name{ensure_html2pdf_backend}
\alias{ensure_html2pdf_backend}
\title{Ensure backend is available}
\usage{
ensure_html2pdf_backend(ask = interactive(), verbose = FALSE)
}
\arguments{
\item{ask}{Logical; ask before downloading when interactive.}

\item{verbose}{Logical; show progress messages.}
}
\value{
Path to the backend executable.
}
\description{
Ensure backend is available
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/app.R
\name{launch_html2pdf_app}
\alias{launch_html2pdf_app}
\title{Launch graphical converter application}
\usage{
launch_html2pdf_app()
}
\value{
Opens a 'Tk' graphical interface for file selection and conversion.
}
\description{
Launch graphical converter application
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/paths.R
\name{find_html2pdf_backend}
\alias{find_html2pdf_backend}
\title{Find configured backend executable}
\usage{
find_html2pdf_backend()
}
\value{
Path to backend executable, or an empty string if not found.
}
\description{
Find configured backend executable
}
